Git.pm: Use stream-like writing in cat_blob()
[git/dscho.git] / git-am.sh
blob3ed18a1886953c7dd1d7ca0e183ba108d42716b9
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 exclude= pass it through git-apply
26 C= pass it through git-apply
27 p= pass it through git-apply
28 patch-format= format the patch(es) are in
29 reject pass it through git-apply
30 resolvemsg= override error message when patch failure occurs
31 continue continue applying patches after resolving a conflict
32 r,resolved synonyms for --continue
33 skip skip the current patch
34 abort restore the original branch and abort the patching operation.
35 committer-date-is-author-date lie about committer date
36 ignore-date use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing* (internal use for git-rebase)"
40 . git-sh-setup
41 . git-sh-i18n
42 prefix=$(git rev-parse --show-prefix)
43 set_reflog_action am
44 require_work_tree
45 cd_to_toplevel
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48 die "$(gettext "You need to set your committer info first")"
50 if git rev-parse --verify -q HEAD >/dev/null
51 then
52 HAS_HEAD=yes
53 else
54 HAS_HEAD=
57 cmdline="git am"
58 if test '' != "$interactive"
59 then
60 cmdline="$cmdline -i"
62 if test '' != "$threeway"
63 then
64 cmdline="$cmdline -3"
67 sq () {
68 git rev-parse --sq-quote "$@"
71 stop_here () {
72 echo "$1" >"$dotest/next"
73 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
74 exit 1
77 safe_to_abort () {
78 if test -f "$dotest/dirtyindex"
79 then
80 return 1
83 if ! test -s "$dotest/abort-safety"
84 then
85 return 0
88 abort_safety=$(cat "$dotest/abort-safety")
89 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
90 then
91 return 0
93 gettextln "You seem to have moved HEAD since the last 'am' failure.
94 Not rewinding to ORIG_HEAD" >&2
95 return 1
98 stop_here_user_resolve () {
99 if [ -n "$resolvemsg" ]; then
100 printf '%s\n' "$resolvemsg"
101 stop_here $1
103 eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
104 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
105 To restore the original branch and stop patching run \"\$cmdline --abort\"."
107 stop_here $1
110 go_next () {
111 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
112 "$dotest/patch" "$dotest/info"
113 echo "$next" >"$dotest/next"
114 this=$next
117 cannot_fallback () {
118 echo "$1"
119 gettextln "Cannot fall back to three-way merge."
120 exit 1
123 fall_back_3way () {
124 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
126 rm -fr "$dotest"/patch-merge-*
127 mkdir "$dotest/patch-merge-tmp-dir"
129 # First see if the patch records the index info that we can use.
130 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
131 "$dotest/patch" &&
132 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
133 git write-tree >"$dotest/patch-merge-base+" ||
134 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
136 say Using index info to reconstruct a base tree...
137 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
138 git apply --cached <"$dotest/patch"
139 then
140 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
141 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
142 else
143 cannot_fallback "$(gettext "Did you hand edit your patch?
144 It does not apply to blobs recorded in its index.")"
147 test -f "$dotest/patch-merge-index" &&
148 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
149 orig_tree=$(cat "$dotest/patch-merge-base") &&
150 rm -fr "$dotest"/patch-merge-* || exit 1
152 say "$(gettext "Falling back to patching base and 3-way merge...")"
154 # This is not so wrong. Depending on which base we picked,
155 # orig_tree may be wildly different from ours, but his_tree
156 # has the same set of wildly different changes in parts the
157 # patch did not touch, so recursive ends up canceling them,
158 # saying that we reverted all those changes.
160 eval GITHEAD_$his_tree='"$FIRSTLINE"'
161 export GITHEAD_$his_tree
162 if test -n "$GIT_QUIET"
163 then
164 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
166 git-merge-recursive $orig_tree -- HEAD $his_tree || {
167 git rerere $allow_rerere_autoupdate
168 echo Failed to merge in the changes.
169 exit 1
171 unset GITHEAD_$his_tree
174 clean_abort () {
175 test $# = 0 || echo >&2 "$@"
176 rm -fr "$dotest"
177 exit 1
180 patch_format=
182 check_patch_format () {
183 # early return if patch_format was set from the command line
184 if test -n "$patch_format"
185 then
186 return 0
189 # we default to mbox format if input is from stdin and for
190 # directories
191 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
192 then
193 patch_format=mbox
194 return 0
197 # otherwise, check the first few non-blank lines of the first
198 # patch to try to detect its format
200 # Start from first line containing non-whitespace
202 while test -z "$l1"
204 read l1
205 done
206 read l2
207 read l3
208 case "$l1" in
209 "From "* | "From: "*)
210 patch_format=mbox
212 '# This series applies on GIT commit'*)
213 patch_format=stgit-series
215 "# HG changeset patch")
216 patch_format=hg
219 # if the second line is empty and the third is
220 # a From, Author or Date entry, this is very
221 # likely an StGIT patch
222 case "$l2,$l3" in
223 ,"From: "* | ,"Author: "* | ,"Date: "*)
224 patch_format=stgit
228 esac
230 esac
231 if test -z "$patch_format" &&
232 test -n "$l1" &&
233 test -n "$l2" &&
234 test -n "$l3"
235 then
236 # This begins with three non-empty lines. Is this a
237 # piece of e-mail a-la RFC2822? Grab all the headers,
238 # discarding the indented remainder of folded lines,
239 # and see if it looks like that they all begin with the
240 # header field names...
241 tr -d '\015' <"$1" |
242 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
243 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
244 patch_format=mbox
246 } < "$1" || clean_abort
249 split_patches () {
250 case "$patch_format" in
251 mbox)
252 if test -n "$rebasing" || test t = "$keepcr"
253 then
254 keep_cr=--keep-cr
255 else
256 keep_cr=
258 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
259 clean_abort
261 stgit-series)
262 if test $# -ne 1
263 then
264 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
266 series_dir=`dirname "$1"`
267 series_file="$1"
268 shift
270 set x
271 while read filename
273 set "$@" "$series_dir/$filename"
274 done
275 # remove the safety x
276 shift
277 # remove the arg coming from the first-line comment
278 shift
279 } < "$series_file" || clean_abort
280 # set the patch format appropriately
281 patch_format=stgit
282 # now handle the actual StGIT patches
283 split_patches "$@"
285 stgit)
286 this=0
287 for stgit in "$@"
289 this=`expr "$this" + 1`
290 msgnum=`printf "%0${prec}d" $this`
291 # Perl version of StGIT parse_patch. The first nonemptyline
292 # not starting with Author, From or Date is the
293 # subject, and the body starts with the next nonempty
294 # line not starting with Author, From or Date
295 perl -ne 'BEGIN { $subject = 0 }
296 if ($subject > 1) { print ; }
297 elsif (/^\s+$/) { next ; }
298 elsif (/^Author:/) { s/Author/From/ ; print ;}
299 elsif (/^(From|Date)/) { print ; }
300 elsif ($subject) {
301 $subject = 2 ;
302 print "\n" ;
303 print ;
304 } else {
305 print "Subject: ", $_ ;
306 $subject = 1;
308 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
309 done
310 echo "$this" > "$dotest/last"
311 this=
312 msgnum=
315 this=0
316 for hg in "$@"
318 this=$(( $this + 1 ))
319 msgnum=$(printf "%0${prec}d" $this)
320 # hg stores changeset metadata in #-commented lines preceding
321 # the commit message and diff(s). The only metadata we care about
322 # are the User and Date (Node ID and Parent are hashes which are
323 # only relevant to the hg repository and thus not useful to us)
324 # Since we cannot guarantee that the commit message is in
325 # git-friendly format, we put no Subject: line and just consume
326 # all of the message as the body
327 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
328 if ($subject) { print ; }
329 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
330 elsif (/^\# Date /) {
331 my ($hashsign, $str, $time, $tz) = split ;
332 $tz = sprintf "%+05d", (0-$tz)/36;
333 print "Date: " .
334 strftime("%a, %d %b %Y %H:%M:%S ",
335 localtime($time))
336 . "$tz\n";
337 } elsif (/^\# /) { next ; }
338 else {
339 print "\n", $_ ;
340 $subject = 1;
342 ' <"$hg" >"$dotest/$msgnum" || clean_abort
343 done
344 echo "$this" >"$dotest/last"
345 this=
346 msgnum=
349 if test -n "$patch_format"
350 then
351 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
352 else
353 clean_abort "$(gettext "Patch format detection failed.")"
356 esac
359 prec=4
360 dotest="$GIT_DIR/rebase-apply"
361 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
362 resolvemsg= resume= scissors= no_inbody_headers=
363 git_apply_opt=
364 committer_date_is_author_date=
365 ignore_date=
366 allow_rerere_autoupdate=
368 if test "$(git config --bool --get am.keepcr)" = true
369 then
370 keepcr=t
373 while test $# != 0
375 case "$1" in
376 -i|--interactive)
377 interactive=t ;;
378 -b|--binary)
379 : ;;
380 -3|--3way)
381 threeway=t ;;
382 -s|--signoff)
383 sign=t ;;
384 -u|--utf8)
385 utf8=t ;; # this is now default
386 --no-utf8)
387 utf8= ;;
388 -k|--keep)
389 keep=t ;;
390 -c|--scissors)
391 scissors=t ;;
392 --no-scissors)
393 scissors=f ;;
394 -r|--resolved|--continue)
395 resolved=t ;;
396 --skip)
397 skip=t ;;
398 --abort)
399 abort=t ;;
400 --rebasing)
401 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
402 -d|--dotest)
403 die "$(gettext "-d option is no longer supported. Do not use.")"
405 --resolvemsg)
406 shift; resolvemsg=$1 ;;
407 --whitespace|--directory|--exclude)
408 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
409 -C|-p)
410 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
411 --patch-format)
412 shift ; patch_format="$1" ;;
413 --reject|--ignore-whitespace|--ignore-space-change)
414 git_apply_opt="$git_apply_opt $1" ;;
415 --committer-date-is-author-date)
416 committer_date_is_author_date=t ;;
417 --ignore-date)
418 ignore_date=t ;;
419 --rerere-autoupdate|--no-rerere-autoupdate)
420 allow_rerere_autoupdate="$1" ;;
421 -q|--quiet)
422 GIT_QUIET=t ;;
423 --keep-cr)
424 keepcr=t ;;
425 --no-keep-cr)
426 keepcr=f ;;
428 shift; break ;;
430 usage ;;
431 esac
432 shift
433 done
435 # If the dotest directory exists, but we have finished applying all the
436 # patches in them, clear it out.
437 if test -d "$dotest" &&
438 last=$(cat "$dotest/last") &&
439 next=$(cat "$dotest/next") &&
440 test $# != 0 &&
441 test "$next" -gt "$last"
442 then
443 rm -fr "$dotest"
446 if test -d "$dotest"
447 then
448 case "$#,$skip$resolved$abort" in
449 0,*t*)
450 # Explicit resume command and we do not have file, so
451 # we are happy.
452 : ;;
454 # No file input but without resume parameters; catch
455 # user error to feed us a patch from standard input
456 # when there is already $dotest. This is somewhat
457 # unreliable -- stdin could be /dev/null for example
458 # and the caller did not intend to feed us a patch but
459 # wanted to continue unattended.
460 test -t 0
463 false
465 esac ||
466 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
467 resume=yes
469 case "$skip,$abort" in
470 t,t)
471 die "$(gettext "Please make up your mind. --skip or --abort?")"
474 git rerere clear
475 git read-tree --reset -u HEAD HEAD
476 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
477 git reset HEAD
478 git update-ref ORIG_HEAD $orig_head
481 if test -f "$dotest/rebasing"
482 then
483 exec git rebase --abort
485 git rerere clear
486 if safe_to_abort
487 then
488 git read-tree --reset -u HEAD ORIG_HEAD
489 git reset ORIG_HEAD
491 rm -fr "$dotest"
492 exit ;;
493 esac
494 rm -f "$dotest/dirtyindex"
495 else
496 # Make sure we are not given --skip, --resolved, nor --abort
497 test "$skip$resolved$abort" = "" ||
498 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
500 # Start afresh.
501 mkdir -p "$dotest" || exit
503 if test -n "$prefix" && test $# != 0
504 then
505 first=t
506 for arg
508 test -n "$first" && {
509 set x
510 first=
512 if is_absolute_path "$arg"
513 then
514 set "$@" "$arg"
515 else
516 set "$@" "$prefix$arg"
518 done
519 shift
522 check_patch_format "$@"
524 split_patches "$@"
526 # -i can and must be given when resuming; everything
527 # else is kept
528 echo " $git_apply_opt" >"$dotest/apply-opt"
529 echo "$threeway" >"$dotest/threeway"
530 echo "$sign" >"$dotest/sign"
531 echo "$utf8" >"$dotest/utf8"
532 echo "$keep" >"$dotest/keep"
533 echo "$keepcr" >"$dotest/keepcr"
534 echo "$scissors" >"$dotest/scissors"
535 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
536 echo "$GIT_QUIET" >"$dotest/quiet"
537 echo 1 >"$dotest/next"
538 if test -n "$rebasing"
539 then
540 : >"$dotest/rebasing"
541 else
542 : >"$dotest/applying"
543 if test -n "$HAS_HEAD"
544 then
545 git update-ref ORIG_HEAD HEAD
546 else
547 git update-ref -d ORIG_HEAD >/dev/null 2>&1
552 git update-index -q --refresh
554 case "$resolved" in
556 case "$HAS_HEAD" in
558 files=$(git ls-files) ;;
560 files=$(git diff-index --ignore-submodules --cached \
561 --name-only HEAD --) ;;
562 esac || exit
563 if test "$files"
564 then
565 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
566 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
568 esac
570 if test "$(cat "$dotest/utf8")" = t
571 then
572 utf8=-u
573 else
574 utf8=-n
576 if test "$(cat "$dotest/keep")" = t
577 then
578 keep=-k
580 case "$(cat "$dotest/keepcr")" in
582 keepcr=--keep-cr ;;
584 keepcr=--no-keep-cr ;;
585 esac
586 case "$(cat "$dotest/scissors")" in
588 scissors=--scissors ;;
590 scissors=--no-scissors ;;
591 esac
592 if test "$(cat "$dotest/no_inbody_headers")" = t
593 then
594 no_inbody_headers=--no-inbody-headers
595 else
596 no_inbody_headers=
598 if test "$(cat "$dotest/quiet")" = t
599 then
600 GIT_QUIET=t
602 if test "$(cat "$dotest/threeway")" = t
603 then
604 threeway=t
606 git_apply_opt=$(cat "$dotest/apply-opt")
607 if test "$(cat "$dotest/sign")" = t
608 then
609 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
610 s/>.*/>/
611 s/^/Signed-off-by: /'
613 else
614 SIGNOFF=
617 last=`cat "$dotest/last"`
618 this=`cat "$dotest/next"`
619 if test "$skip" = t
620 then
621 this=`expr "$this" + 1`
622 resume=
625 while test "$this" -le "$last"
627 msgnum=`printf "%0${prec}d" $this`
628 next=`expr "$this" + 1`
629 test -f "$dotest/$msgnum" || {
630 resume=
631 go_next
632 continue
635 # If we are not resuming, parse and extract the patch information
636 # into separate files:
637 # - info records the authorship and title
638 # - msg is the rest of commit log message
639 # - patch is the patch body.
641 # When we are resuming, these files are either already prepared
642 # by the user, or the user can tell us to do so by --resolved flag.
643 case "$resume" in
645 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
646 <"$dotest/$msgnum" >"$dotest/info" ||
647 stop_here $this
649 # skip pine's internal folder data
650 sane_grep '^Author: Mail System Internal Data$' \
651 <"$dotest"/info >/dev/null &&
652 go_next && continue
654 test -s "$dotest/patch" || {
655 eval_gettextln "Patch is empty. Was it split wrong?
656 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
657 To restore the original branch and stop patching run \"\$cmdline --abort\"."
658 stop_here $this
660 rm -f "$dotest/original-commit" "$dotest/author-script"
661 if test -f "$dotest/rebasing" &&
662 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
663 -e q "$dotest/$msgnum") &&
664 test "$(git cat-file -t "$commit")" = commit
665 then
666 git cat-file commit "$commit" |
667 sed -e '1,/^$/d' >"$dotest/msg-clean"
668 echo "$commit" > "$dotest/original-commit"
669 get_author_ident_from_commit "$commit" > "$dotest/author-script"
670 else
672 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
673 echo
674 cat "$dotest/msg"
676 git stripspace > "$dotest/msg-clean"
679 esac
681 if test -f "$dotest/author-script"
682 then
683 eval $(cat "$dotest/author-script")
684 else
685 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
686 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
687 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
690 if test -z "$GIT_AUTHOR_EMAIL"
691 then
692 gettextln "Patch does not have a valid e-mail address."
693 stop_here $this
696 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
698 case "$resume" in
700 if test '' != "$SIGNOFF"
701 then
702 LAST_SIGNED_OFF_BY=`
703 sed -ne '/^Signed-off-by: /p' \
704 "$dotest/msg-clean" |
705 sed -ne '$p'
707 ADD_SIGNOFF=`
708 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
709 test '' = "$LAST_SIGNED_OFF_BY" && echo
710 echo "$SIGNOFF"
712 else
713 ADD_SIGNOFF=
716 if test -s "$dotest/msg-clean"
717 then
718 cat "$dotest/msg-clean"
720 if test '' != "$ADD_SIGNOFF"
721 then
722 echo "$ADD_SIGNOFF"
724 } >"$dotest/final-commit"
727 case "$resolved$interactive" in
729 # This is used only for interactive view option.
730 git diff-index --ignore-submodules -p --cached \
731 HEAD -- >"$dotest/patch"
733 esac
734 esac
736 resume=
737 if test "$interactive" = t
738 then
739 test -t 0 ||
740 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
741 action=again
742 while test "$action" = again
744 gettextln "Commit Body is:"
745 echo "--------------------------"
746 cat "$dotest/final-commit"
747 echo "--------------------------"
748 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
749 # in your translation. The program will only accept English
750 # input at this point.
751 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
752 read reply
753 case "$reply" in
754 [yY]*) action=yes ;;
755 [aA]*) action=yes interactive= ;;
756 [nN]*) action=skip ;;
757 [eE]*) git_editor "$dotest/final-commit"
758 action=again ;;
759 [vV]*) action=again
760 git_pager "$dotest/patch" ;;
761 *) action=again ;;
762 esac
763 done
764 else
765 action=yes
768 if test -f "$dotest/final-commit"
769 then
770 FIRSTLINE=$(sed 1q "$dotest/final-commit")
771 else
772 FIRSTLINE=""
775 if test $action = skip
776 then
777 go_next
778 continue
781 if test -x "$GIT_DIR"/hooks/applypatch-msg
782 then
783 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
784 stop_here $this
787 say "$(eval_gettext "Applying: \$FIRSTLINE")"
789 case "$resolved" in
791 # When we are allowed to fall back to 3-way later, don't give
792 # false errors during the initial attempt.
793 squelch=
794 if test "$threeway" = t
795 then
796 squelch='>/dev/null 2>&1 '
798 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
799 apply_status=$?
802 # Resolved means the user did all the hard work, and
803 # we do not have to do any patch application. Just
804 # trust what the user has in the index file and the
805 # working tree.
806 resolved=
807 git diff-index --ignore-submodules --quiet --cached HEAD -- && {
808 gettextln "No changes - did you forget to use 'git add'?
809 If there is nothing left to stage, chances are that something else
810 already introduced the same changes; you might want to skip this patch."
811 stop_here_user_resolve $this
813 unmerged=$(git ls-files -u)
814 if test -n "$unmerged"
815 then
816 gettextln "You still have unmerged paths in your index
817 did you forget to use 'git add'?"
818 stop_here_user_resolve $this
820 apply_status=0
821 git rerere
823 esac
825 if test $apply_status != 0 && test "$threeway" = t
826 then
827 if (fall_back_3way)
828 then
829 # Applying the patch to an earlier tree and merging the
830 # result may have produced the same tree as ours.
831 git diff-index --ignore-submodules --quiet --cached \
832 HEAD -- && {
833 say "$(gettext "No changes -- Patch already applied.")"
834 go_next
835 continue
837 # clear apply_status -- we have successfully merged.
838 apply_status=0
841 if test $apply_status != 0
842 then
843 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
844 stop_here_user_resolve $this
847 if test -x "$GIT_DIR"/hooks/pre-applypatch
848 then
849 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
852 tree=$(git write-tree) &&
853 commit=$(
854 if test -n "$ignore_date"
855 then
856 GIT_AUTHOR_DATE=
858 parent=$(git rev-parse --verify -q HEAD) ||
859 say >&2 "$(gettext "applying to an empty history")"
861 if test -n "$committer_date_is_author_date"
862 then
863 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
864 export GIT_COMMITTER_DATE
865 fi &&
866 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
867 ) &&
868 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
869 stop_here $this
871 if test -f "$dotest/original-commit"; then
872 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
875 if test -x "$GIT_DIR"/hooks/post-applypatch
876 then
877 "$GIT_DIR"/hooks/post-applypatch
880 go_next
881 done
883 if test -s "$dotest"/rewritten; then
884 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
885 if test -x "$GIT_DIR"/hooks/post-rewrite; then
886 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
890 rm -fr "$dotest"
891 git gc --auto